//=============================================================================
// Pinata remixed for Monster Hunt
// and renamed YardSale
// Remix by gopostal and TheManNo1{HoF}
// Original Pinata:
// Author: |404|shiftre
//=============================================================================

class YardSale expands Mutator config(YardSale);

var config bool noPowerups;
var config bool bInitialized;
var config class<Weapon> AlwaysDrop[5];
var config class<Weapon> NeverDrop[5];

function PostBeginPlay()
{
	if ( bInitialized )
		return;

	bInitialized = TRUE;
}

	
function bool PreventDeath (Pawn Killed, Pawn Killer, name damageType, vector HitLocation)
{
	local actor dropped;
	local float speed;
	local float temp;
	local int charge;
	local int finalcount;
	local int timecharge;
	local bool bToggleLoop;
	local vector X,Y,Z;
	local int i;

	//Local list of droppable inv types
	local inventory inv;
	local weapon weap;
	local udamage udam;
	local ut_jumpboots jboots; //Must be handled individually because of jump charge

	//firstpass = true;
	
	  if(Killer != None && Killer.IsA('ScriptedPawn')) //Excludes map caused deaths and suicides
	  {
	//Cycle through inventory, dropping weapons, pickups and armor
	    for (inv=Killed.Inventory; inv!=None; inv=inv.Inventory)
	     {
		weap = Weapon(inv);
		if ( (weap != None))
		{		
			// This is our special dropping system. It drops items in a player's
			// inventory by chance only if they are not listed in Always/Never Drop.
			for(i=0; i<5; i++)
				if(weap.class==NeverDrop[i])
				{ // If bToggleLoop is true, we 'continue' (end the current loop).
					bToggleLoop=True;
					break;
				}
			if(bToggleLoop) // If done inside the preceding for loop, it wont end the larger loop.
				continue;

			// NOTE: We will only reach this point if bToggleLoops is false;
			for(i=0; i<5; i++)
				if(weap.class==AlwaysDrop[5])
				{ // Here the role of bToggleLoop changes. Now if it is true, we don't 'continue'.
					bToggleLoop=True;
					break;
				}

			// Finally, if bToggleLoop is still false, and a random % + 20% is less than or equal to the % of players on the server, 'continue'.
			if(!bToggleLoop && frand()+0.2<=(Level.Game.GameReplicationInfo.NumPlayers/Level.Game.MaxPlayers))
				continue;

			//Get ammo count for this weapon			
			charge = weap.AmmoType.AmmoAmount;
			
			if (WarheadLauncher(weap)!=none && charge == 0)
				continue;	
				
			//Do not drop if impact hammer or chainsaw. Add Translocator?
			if (ImpactHammer(weap)!= None || ChainSaw(weap)!=none || !weap.bCanThrow) 
				continue;																				

			//Spawn this item & set attributes
			dropped = Spawn(weap.Class,,,Killed.Location);
			weap = Weapon(dropped);			
			if (charge ==0)
				weap.PickupAmmoCount=1;
			else
				weap.PickupAmmoCount = charge;
			if ( weap != None )
			{ 
				weap.RespawnTime = 0.0; //don't respawn
				weap.BecomePickup();
				weap.bTossedOut = true;	
				weap.bWeaponStay = false;
				weap.GotoState('PickUp', 'Dropped');	
			}
			
		}
		else if (!noPowerUps)
                {
			 if (UDamage(inv) != None) 
                         {
				udam = UDamage(inv);
				if (udam != None) 
                                        {
				 	     //don't make much sense, but works
					     if (udam.TimerRate-udam.TimerCounter < 5)
						charge = 50;
					     else
						charge =((udam.TimerRate-udam.TimerCounter)*10);
									
					        dropped = Spawn(udam.Class,,,Killed.Location);
					        udam = UDamage(dropped);
					        udam.Charge = charge;
					    if (udam != None) 
                                            {
						udam.RespawnTime = 0.0;
						udam.BecomePickup();
	                                    }
		                         }
	               	  }
			else if (UT_jumpboots(inv) != None) 
                        {
				jboots = UT_jumpboots(inv);
				if (jboots != None) 
                                {
					//Since jboots have a timelimit & charge limit, record both				
					timecharge = jboots.TimeCharge;
					charge = jboots.Charge;
					dropped = Spawn(jboots.Class,,,Killed.Location);
					jboots = UT_jumpboots(dropped);
					jboots.TimeCharge = timecharge;
					jboots.Charge = charge;
					if (jboots != None) 
                                        {
						jboots.RespawnTime = 0.0;
						jboots.BecomePickup();
					}
				}				
			}	
                        //Else drop anything else that is not ammo or relics (dropped with weapons)
			else if (Ammo(inv) == None && !inv.IsA('Relic') && !inv.IsA('RelicInventory')) 
                        {
				charge = inv.Charge;
				dropped = Spawn(inv.Class,,,Killed.Location);
				inv = Inventory(dropped);
				inv.Charge = charge;
				if (inv != None) 
                                {
					inv.RespawnTime = 0.0;
					inv.BecomePickup();
				}
			}			
		}				
				
		//Now set the speed of the dropped item based off killed's speed
		setVelocity (Killed, dropped);

		//Destroy Item from killed's inventory
		Killed.Inventory.Destroy();
	}
	
	//Call next mutator down the line
	if ( NextMutator != None )
		NextMutator.ScoreKill(Killer, Killed);
   }
}

//Set's the velocity of an actor dropped by pawn Other
function setVelocity (Pawn Other, Actor dropped)		 
{
	local float speed;
	
	//Now set the speed of the dropped item based off killed's speed. Rand gives a nice "fan" effect
	speed = VSize(Other.Velocity);			
	if ( dropped != None )	
        {
		dropped.RemoteRole = ROLE_DumbProxy;
		dropped.SetPhysics(PHYS_Falling);
		dropped.bCollideWorld = true;
		if (speed != 0)
			dropped.Velocity = Normal(Other.Velocity/speed + 0.5 * VRand()) * (speed + 280);
			else 
                        {
				dropped.Velocity.X = 0;
				dropped.Velocity.Y = 0;
				dropped.Velocity.Z = 0;
			}
	}	
}

//Add to ini file
defaultproperties
{
     bInitialized=True
     noPowerups=False
}

